/* vue-property-decorator verson 3.1.0 MIT LICENSE copyright 2016 kaorun343 */
"use strict";
var vue_class_component_1 = require("vue-class-component");
/**
 * decorator of a prop
 * @param  {PropOption}        options the option for the prop
 * @return {PropertyDecorator}         PropertyDecorator
 */
function prop(options) {
    return function (target, propertyKey) {
        (target.constructor.props || (target.constructor.props = {}))[propertyKey] = options;
    };
}
exports.prop = prop;
/**
 * decorator of a watch function
 * @param  {string}            path the path or the expression to observe
 * @param  {WatchOption}       WatchOption
 * @return {MethodDecorator}      MethodDecorator
 */
function watch(path, options) {
    if (options === void 0) { options = {}; }
    var _a = options.deep, deep = _a === void 0 ? false : _a, _b = options.immediate, immediate = _b === void 0 ? false : _b;
    return function (target, handler) {
        (target.constructor.watch || (target.constructor.watch = {}))[path] = {
            handler: handler,
            deep: deep,
            immediate: immediate
        };
    };
}
exports.watch = watch;
function Component(options) {
    return function (Class) {
        if (options.style) {
            (Class.props || (Class.props = {}))['style'] = {
                type: Object,
                default: function () {
                    return options.style;
                }
            };
        }
        Object.assign(options, { props: Class.props, watch: Class.watch });
        return vue_class_component_1.default(options)(Class);
    };
}
exports.Component = Component;
